Param fOutFile, cQuery
private aData, cStr, cAction
aData = new array()

Set talk OFF   ////// turn off interactive mode
Set century ON ////// Y2K fix 
cAction = " "

Try ////// Global try/catch prevents CGI lockup 
 
   // Get the Query string from the environment
   cEnv = getenv("QUERY_STRING")
   *GenerateMessage(fOutFile,cEnv)  // for debugging
   if len(trim(cEnv)) = 0
      errorPage("Message: No data received from server!",0)
   endif

   // EXEFILENAME is always the first pair
   // "&" is used as delimiter in CGI,
   //  so look for second pair
   if at("&",cEnv) > 0
      cEnv = substr(cEnv,at("&",cEnv)+1)
   endif

   // cEnv will look like EXEFILENAME=prg_name.EXE&_op_name.x=116&_op_name.y=13
   // All buttons on the web form start with "_op_" to help identify the "name" as a button.
   // Store the Name of the button to a memory variable called cAction.
   // It is used in the Case Statement below to control the application.
   // The button name will always be passed as name.x=116&name.y=13
   do while at("=",cEnv) > 0
      if at("&",cEnv) > 0 // if more than one pair left
         cData = OEMFormat(substr(cEnv,1,at("&",cEnv)-1))
	 if Left(cData,4) = "_op_" AND at(".x=",cData) > 0   
	    cAction = substr(cdata,5,at(".x=",cData)-5)
         endif
         cEnv = substr(cEnv,at("&",cEnv)+1)
      // If last pair 
      else
         cData = OEMFormat(cEnv)    // take the whole string
         cEnv = " "
      endif
      
      // aData is not used in this simple application.
      //if len(trim(cData)) > 0    
         //aData.add(cData)
      //endif
   enddo

   
   // The name of the Command Button is now stored in cAction

   // Used for debugging
   *cMessage = "cAction = " + cAction 
   *GenerateMessage(fOutFile,cMessage)  
   
   Do Case
   Case (cAction == "add")
           cMessage="User at " + getenv("REMOTE_ADDR") + " pushed the " + trim(cAction)+ " button"
           GenerateMessage(fOutFile, cMessage)

   Case (cAction == "edit")
           cMessage="User at " + getenv("REMOTE_ADDR") + " pushed the " + trim(cAction)+ " button"
           GenerateMessage(fOutFile, cMessage)

   Case (cAction == "save")
           cMessage="User at " + getenv("REMOTE_ADDR") + " pushed the " + trim(cAction)+ " button"
           GenerateMessage(fOutFile, cMessage)
	  
   Case (cAction == "abandon")
           cMessage="User at " + getenv("REMOTE_ADDR") + " pushed the " + trim(cAction)+ " button"
           GenerateMessage(fOutFile, cMessage)
   
   Case (cAction == "delete")
           cMessage="User at " + getenv("REMOTE_ADDR") + " pushed the " + trim(cAction)+ " button"
           GenerateMessage(fOutFile, cMessage)
      
   Otherwise 
      GenerateMessage(fOutFile,"Error in cAction") 
   EndCase

catch (exception e)
 
    errorpage(e.message,e.lineno)
 
endtry 
 
Quit


function ErrorPage(cMess,nLineNo)
   ////// Create new response file
   nLineNo = iif(empty(nLineNo),0,nLineNo)

   fOut = new file()
   fOut.Open(fOutFile,"RA")
   fOut.Puts("")

   ////// Generate HTML error page
   fOut.Puts(" ")
   fOut.Puts("<HTML>")
   fOut.Puts("<HEAD><Title>Visual dBASE 7 Web Wizard Error Page</Title>")
   fOut.Puts("<BODY>")
   fOut.Puts("")
   fOut.Puts("   <H2><I>Sorry,an error ocurred on the host!</I></H2>")
   fOut.Puts("")
   fOut.Puts("   <P>Error: "+cMess+" </P>")
   fOut.Puts("   <P>Line No.: "+ltrim(str(nLineNo,5))+"</p>")
   fOut.Puts("   <P>Press the back button and try again, or contact the Webmaster for assistance")
   fOut.Puts("")
   fOut.Puts("</BODY>")
   fOut.Puts("</HTML>")
   fOut.close()
   Quit
 
///////////// Function OEMFormat //////////////////////////////
///////////// Purpose - transforms CGI escape chars to OEM/////
///////////// Param: cStr - Environment Variable Value ////////

function OEMFormat(cStr)
   ////// remove terminating character
   if at("%21",cStr) > 0
      cStr = substr(cStr,1,at("%21",cStr)-1)
   endif
   ////// remove "Pluses" used as space keepers in CGI
   do while at("+",cStr) > 0
      cStr = substr(cStr,1,at("+",cStr)-1) + " "+;
             substr(cStr,at("+",cStr)+1)
   enddo
   ////// add in "CRs" sent as escape characters
   do while at("%0D%0A",cStr) > 0
      cStr = substr(cStr,1,at("%0D%0A",cStr)-1) +chr(13)+;
             substr(cStr,at("%0D%0A",cStr)+3)
   enddo
   ////// convert escape characters back to oem chars
   nLeft = 1
   do while at("%",substr(cStr,nLeft) ) > 0
      nPos = at("%",substr(cStr,nLeft))+nLeft-1
      nLeft = nPos+1
      if nPos <= len(cStr)-2
         cStr = left(cStr,nPos-1)+ chr(htoi(substr(cStr,nPos+1,2)))+;
         substr(cStr,nPos+3)
      endif
   enddo
 
   return cStr

function GenerateMessage(fOutFile,cMessage)
   fOut = new File()
   If not file(fOutFile)
      fOut.Create(fOutFile,"RA")
   else
      fOut.Open(fOutFile,"RA")
   Endif
 
   fOut.Puts(" ")
   fOut.Puts("<HTML>")
   fOut.Puts("<TITLE>Data Entered</TITLE>")
   fOut.Puts('<body bgcolor="#ffffff">')
   fOut.Puts("<blockquote><center>")
   fOut.Puts(cMessage)
   fOut.Puts("</Blockquote></center>")
   fOut.Puts("</Body>")
   fOut.Puts("</HTML>")
 
   fOut.close()
   quit



